Data - Update Preview
Data Update API
Applies to: S1 pricing tier.
The Data Update API allows the caller to update a previously uploaded data content.
You can use this API in a scenario like adding or removing geofences to or from an existing collection of geofences. Geofences are uploaded using the Data Upload API, for use in the Azure Maps Geofencing Service.
Please note that the Update API will replace and override the existing data content.
Submit Update Request
To update your content you will use a PUT request. The request body will contain the new data that will replace
the existing data. The Content-Type header will be set to the content type of the data, and the path will contain
the udid of the data to be update.
For example, to update a collection of geofences that were previously uploaded using the Upload API, place the new
geofence content in the request body. Set the udid parameter in the path to the udid of the data received
previously in the upload API response. And set the Content-Type header to one of the following media types:
application/jsonapplication/vnd.geo+jsonapplication/octet-stream
Here's a sample request body for updating a simple Geofence. It's represented as a circle geometry using a center
point and a radius. The sample below is in GeoJSON:
{
"type": "FeatureCollection",
"features": [{
"type": "Feature",
"geometry": {
"type": "Point",
"coordinates": [-122.126986, 47.639754]
},
"properties": {
"geometryId": "001",
"radius": 500
}
}]
}
The previously uploaded geofence had a radius of 100m. The above request will update it to 500m.
The Data Update API performs a long-running request.
Data Update Limits
Please, be aware that currently every Azure Maps account has a data storage limit.
Once the storage limit is reached, all the new upload API calls will return a 409 Conflict http error response.
You can always use the Data Delete API to
delete old/unused content and create space for new uploads.
PUT https://{geography}.atlas.microsoft.com/mapData/{udid}?api-version=1.0
PUT https://{geography}.atlas.microsoft.com/mapData/{udid}?subscription-key={subscription-key}&api-version=1.0
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
geography
|
path | True |
|
This parameter specifies where the Azure Maps Creator resource is located. Valid values are us and eu. |
|
udid
|
path | True |
|
The unique data id for the content. The |
|
api-version
|
query | True |
|
Version number of Azure Maps API. Current version is 1.0 |
|
subscription-key
|
query |
|
One of the Azure Maps keys provided from an Azure Map Account. Please refer to this article for details on how to manage authentication. |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| x-ms-client-id |
|
Specifies which account is intended for usage in conjunction with the Azure AD security model. It represents a unique ID for the Azure Maps account and can be retrieved from the Azure Maps management plane Account API. To use Azure AD security in Azure Maps see the following articles for guidance. |
Request Body
| Name | Type | Description |
|---|---|---|
| UpdateContent |
|
The new content that will update/replace the previously uploaded content. |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
Data update failed. The uploaded content did not satisfy all the validation checks. The response body contains all the errors that were encountered. |
|
| 201 Created |
The resource has been created successfully. Headers
|
|
| 202 Accepted |
Supported only for async request. Request Accepted: The request has been accepted for processing. Please use the URL in the Location Header to retry or access the results. Headers
|
|
| 400 Bad Request |
Bad request: one or more parameters were incorrectly specified or are mutually exclusive. |
|
| 401 Unauthorized |
Access denied due to invalid subscription key or invalid Azure Active Directory (Azure AD) bearer token. Make sure to provide a valid key for an active Azure subscription and Maps resource. Otherwise, verify the WWW-Authenticate header for error code and description of the provided Azure AD bearer token. Headers
|
|
| 403 Forbidden |
Permission, capacity, or authentication issues. |
|
| 404 Not Found |
Not Found: the requested resource could not be found, but it may be available again in the future. |
|
| 500 Internal Server Error |
An error occurred while processing the request. Please try again later. |
Security
AADToken
These are the Azure Active Directory OAuth2 Flows. When paired with Azure role-based access control it can be used to control access to Azure Maps REST APIs. Azure role-based access controls are used to designate access to one or more Azure Maps resource account or sub-resources. Any user, group, or service principal can be granted access via a built-in role or a custom role composed of one or more permissions to Azure Maps REST APIs.
To implement scenarios, we recommend viewing authentication concepts. In summary, this security definition provides a solution for modeling application(s) via objects capable of access control on specific APIs and scopes.
Notes
- This security definition requires the use of the
x-ms-client-idheader to indicate which Azure Maps resource the application is requesting access to. This can be acquired from the Maps management API.
The Authorization URL is specific to the Azure public cloud instance. Sovereign clouds have unique Authorization URLs and Azure Active directory configurations.
*
The Azure role-based access control is configured from the Azure management plane via Azure portal, PowerShell, CLI, Azure SDKs, or REST APIs.
*
Usage of the Azure Maps Web SDK allows for configuration based setup of an application for multiple use cases.
- Currently, Azure Active Directory v1.0 or v2.0 supports Work, School, and Guests but does not support Personal accounts.
Type:
oauth2
Flow:
implicit
Authorization URL:
https://login.microsoftonline.com/common/oauth2/authorize
Scopes
| Name | Description |
|---|---|
| https://atlas.microsoft.com/.default | https://atlas.microsoft.com/.default |
subscription-key
This is a shared key that is provisioned when creating an Azure Maps resource through the Azure management plane via Azure portal, PowerShell, CLI, Azure SDKs, or REST APIs.
With this key, any application is authorized to access all REST APIs. In other words, these can currently be treated as master keys to the account which they are issued for.
For publicly exposed applications, our recommendation is to use server-to-server access of Azure Maps REST APIs where this key can be securely stored.
Type:
apiKey
In:
query
SAS Token
This is a shared access signature token is created from the List SAS operation on the Azure Maps resource through the Azure management plane via Azure portal, PowerShell, CLI, Azure SDKs, or REST APIs.
With this token, any application is authorized to access with Azure role-based access controls and fine-grain control to the expiration, rate, and region(s) of use for the particular token. In other words, the SAS Token can be used to allow applications to control access in a more secured way than the shared key.
For publicly exposed applications, our recommendation is to configure a specific list of allowed origins on the Map account resource to limit rendering abuse and regularly renew the SAS Token.
Type:
apiKey
In:
header
Examples
Update previously uploaded GeoJSON data containing geometries that represent a collection of geofences
Sample Request
PUT https://us.atlas.microsoft.com/mapData/25084fb7-307a-4720-8f91-7952a0b91012?subscription-key=[subscription-key]&api-version=1.0
{
"type": "FeatureCollection",
"features": [
{
"type": "Feature",
"geometry": {
"type": "Point",
"coordinates": [
-122.126986,
47.639754
]
},
"properties": {
"geometryId": "001",
"radius": 500
}
}
]
}
Sample Response
Location: https://atlas.microsoft.com/mapData/metadata/{udid}?api-version=1.0
Access-Control-Expose-Headers: Location
{
"operationId": "{operationId}",
"status": "Succeeded",
"created": "2020-01-02 1:02:03 AM +00:00",
"resourceLocation": "https://atlas.microsoft.com/mapData/metadata/{resourceId}?api-version=1.0"
}
Location: https://atlas.microsoft.com/mapData/operations/{operationId}?api-version=1.0
Access-Control-Expose-Headers: Location
{
"error": {
"code": "400 Bad Request",
"message": "Upload request failed. Your data has been removed as we encountered the following problems with it: Map data is not a valid GeoJSON geometry."
}
}
{
"error": {
"code": "400 BadRequest",
"message": "Bad request: one or more parameters were incorrectly specified or are mutually exclusive."
}
}
{
"error": {
"code": "401 Unauthorized",
"message": "Access denied due to invalid subscription key. Make sure to provide a valid key for an active subscription."
}
}
{
"error": {
"code": "403 Forbidden",
"message": "Permission, capacity, or authentication issues."
}
}
{
"error": {
"code": "404 NotFound",
"message": "Not Found: the requested resource could not be found, but it may be available again in the future."
}
}
{
"error": {
"code": "500 InternalServerError",
"message": "An error occurred while processing the request. Please try again later."
}
}
Definitions
|
Long |
The response model for a Long-Running Operations API. |
|
OData |
This object is returned when an error occurs in the Azure Maps API. |
|
OData |
This response object is returned when an error occurs in the Azure Maps API. |
| type |
The status state of the request. |
LongRunningOperationResult
The response model for a Long-Running Operations API.
| Name | Type | Description |
|---|---|---|
| created |
|
The created timestamp. |
| error |
This object is returned when an error occurs in the Azure Maps API. |
|
| operationId |
|
The Id for this long-running operation. |
| resourceLocation |
|
The location URI for details about the created resource. This is only provided when the request was successfully completed. |
| status |
The status state of the request. |
|
| warning |
This object is returned when an error occurs in the Azure Maps API. |
ODataError
This object is returned when an error occurs in the Azure Maps API.
| Name | Type | Description |
|---|---|---|
| code |
|
The ODataError code. |
| details |
This object is returned when an error occurs in the Azure Maps API. |
|
| message |
|
If available, a human-readable description of the error. |
| target |
|
If available, the target causing the error. |
ODataErrorResponse
This response object is returned when an error occurs in the Azure Maps API.
| Name | Type | Description |
|---|---|---|
| error |
This object is returned when an error occurs in the Azure Maps API. |
type
The status state of the request.
| Name | Type | Description |
|---|---|---|
| Failed |
|
The request has one or more failures. |
| NotStarted |
|
The request has not started processing yet. |
| Running |
|
The request has started processing. |
| Succeeded |
|
The request has successfully completed. |